Attribute VB_Name = "GlobalMemory"
Option Explicit

Public Declare Function GlobalAddAtom Lib "kernel32" Alias "GlobalAddAtomA" (ByVal lpString As String) As Integer
Public Declare Function GlobalFindAtom Lib "kernel32" Alias "GlobalFindAtomA" (ByVal lpString As String) As Integer
Public Declare Function GlobalGetAtomName Lib "kernel32" Alias "GlobalGetAtomNameA" (ByVal nAtom As Integer, ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GlobalDeleteAtom Lib "kernel32" (ByVal nAtom As Integer) As Integer


'\\ --[AddGlobalString]----------------------------------------------------
'\\ Adds a string to global memory and returns a hadnle to that
'\\ memory location so that the string cna be passed between
'\\ programs
'\\ -----------------------------------------------------------------------
Public Function AddGlobalString(ByVal sData As String) As Long

'\\ If it doesn't already exist, add it
Dim hAtom As Long

hAtom = GlobalFindAtom(sData)
If hAtom = 0 Then
    hAtom = GlobalAddAtom(sData)
End If

AddGlobalString = hAtom

End Function

Public Function GetGlobalString(ByVal hGlobal As Long) As String

Dim sRet As String

sRet = String$(1024, 0)

If GlobalGetAtomName(hGlobal, sRet, Len(sRet)) > 0 Then
    If InStr(sRet, Chr$(0)) > 0 Then
        sRet = Left$(sRet, InStr(sRet, Chr$(0)) - 1)
    End If
End If

GetGlobalString = sRet

End Function


